blob: 0dac3a4cd1ecf4b787ba83c87a2c62992290a58c [file] [log] [blame]
Neels Hofmeyr53e758a2017-05-29 22:53:34 +02001#!source_this_file
2
3# Common parts for osmo-gsm-tester jenkins build scripts. Use like in below example:
4#
5#--------------
6# #!/bin/sh
7# set -e -x
8# base="$PWD"
9# name="osmo-name"
10# . "$(dirname "$0")/jenkins-build-common.sh"
11#
12# build_repo libosmocore --configure --opts
13# build_repo libosmo-foo special_branch --configure --opts
14# build_repo osmo-bar
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +010015# build_repo_dir openbsc ./openbsc
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020016#
17# create_bin_tgz
18#--------------
19#
20# Some explanations:
21#
22# To allow calling from arbitrary working directories, other scripts should
23# source this file like shown above.
24#
25# Sourcing scripts must provide some variables/functions, see above.
26# In addition, these values can optionally be passed to override:
27# git_url, prefix, prefix_real, BUILD_NUMBER
28#
29# CONFIGURE_FLAGS may contain flags that should be passed to all builds'
30# ./configure steps (useful e.g. for building in the sysmobts SDK).
31#
32# For each built repository, a specific git branch or hash can be provided by
33# environment variable: OSMO_GSM_TESTER_BUILD_$repo="<git-hash>"
34# NOTE: convert $repo's dashes to underscore. For example:
35# OSMO_GSM_TESTER_BUILD_osmo_hlr="f001234abc"
36# OSMO_GSM_TESTER_BUILD_libosmocore="my/branch"
37# ("origin/" is prepended to branch names automatically)
38
39if [ -z "$name" -o -z "$base" ]; then
40 set +x
41 echo "Some environment variables are not provided as required by jenkins-build-common.sh. Error."
42 exit 1
43fi
44
Pau Espin Pedrol70c01ec2020-02-17 17:42:05 +010045git_url="${git_url:-git://git.osmocom.org}"
46prefix="${prefix:-$base/inst-$name}"
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020047# prefix_real is usually identical with prefix, except when installing to a
48# different $DESTDIR than /, which is the case for example when building
49# osmo-bts within the sysmoBTS SDK
Pau Espin Pedrol70c01ec2020-02-17 17:42:05 +010050prefix_real="${prefix_real:-$prefix}"
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020051
Holger Hans Peter Freyther90b05072018-09-23 15:14:00 +010052# Flag to be used to enable ASAN in builds. Defaults to enable ASAN builds and
53# it can be disabled by passing SANITIZE_FLAGS="" to the build.
Pau Espin Pedrol70c01ec2020-02-17 17:42:05 +010054SANITIZE_FLAGS="${SANITIZE_FLAGS:---enable-sanitize}"
Holger Hans Peter Freyther90b05072018-09-23 15:14:00 +010055
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020056export PKG_CONFIG_PATH="$prefix_real/lib/pkgconfig:$PKG_CONFIG_PATH"
57export LD_LIBRARY_PATH="$prefix_real/lib:$LD_LIBRARY_PATH"
58
59# Show current environment. Sometimes the LESS_ vars have ansi colors making a
60# mess, so exclude those.
61env | grep -v "^LESS" | sort
62
63# clean the workspace
Neels Hofmeyra8647f32017-09-13 19:17:08 +020064rm -f "$base"/*.build-*.tgz
65rm -f "$base"/*.build-*.md5
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020066rm -rf "$prefix_real"
67mkdir -p "$prefix_real"
68
69have_repo() {
70 repo="$1"
71 branch="${2-master}"
72
73 # Evaluate environment for instructions to build a specific git hash.
74 # Using a hash as $branch above unfortunately doesn't work.
75 branch_override_var="$(echo "OSMO_GSM_TESTER_BUILD_$repo" | sed 's/-/_/g')"
76 branch_override="$(eval "echo \$$branch_override_var")"
77 if [ -n "$branch_override" ]; then
78 branch="$branch_override"
79 fi
80
81 cd "$base"
Holger Hans Peter Freyther9eafb132018-09-18 22:55:05 +010082 if [ -d "$repo" ]; then
83 cd "$repo"
84 git fetch
85 else
86 git clone "$git_url/$repo" "$repo"
87 cd "$repo"
88 fi
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020089
Neels Hofmeyrb398b522017-06-23 04:13:30 +020090
91 # Figure out whether we need to prepend origin/ to find branches in upstream.
92 # Doing this allows using git hashes instead of a branch name.
Neels Hofmeyr851802b2017-06-23 03:52:26 +020093 if git rev-parse "origin/$branch"; then
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020094 branch="origin/$branch"
95 fi
96
Holger Hans Peter Freyther9eafb132018-09-18 22:55:05 +010097 git checkout -B build_branch "$branch"
Neels Hofmeyr2581b502017-06-23 04:07:40 +020098 rm -rf *
Neels Hofmeyr53e758a2017-05-29 22:53:34 +020099 git reset --hard "$branch"
100
101 git rev-parse HEAD
102
Pau Espin Pedrolcbbe5d82018-09-18 15:39:17 +0200103 echo "$(git rev-parse HEAD) $repo" >> "$prefix_real/${name}_git_hashes.txt"
Pau Espin Pedrol70439962018-05-17 17:09:38 +0200104
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200105 cd "$base"
106}
107
108build_repo() {
109 # usage: build_repo <name> [<branch>] [--configure-opts [...]]
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +0100110 dir="$1"
111 shift
112 build_repo_dir "${dir}" "./" $@
113}
114
115build_repo_dir() {
116 # usage: build_repo_dir <name> <dir> [<branch>] [--configure-opts [...]]
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200117 dep="$1"
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +0100118 dir="$2"
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200119 branch="master"
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +0100120 if [ -z "$(echo "$3" | grep '^-')" ]; then
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200121 # second arg does not start with a dash, it's empty or a branch
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +0100122 branch="$3"
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200123 if [ -n "$branch" ]; then
124 # we had a branch arg, need to shift once more to get config options
125 shift
126 else
127 branch="master"
128 fi
129 fi
130 shift
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +0100131 shift
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200132 configure_opts="$@"
133
134 set +x; echo "
135
136====================== $dep
137
138"; set -x
139
140
141 have_repo "$dep" "$branch"
142
Holger Hans Peter Freythercb132bd2018-09-15 10:21:40 +0100143 cd "$dep/${dir}"
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200144
Pau Espin Pedroladdf78e2020-02-03 15:47:01 +0100145 if [ -f configure.ac ]; then
146 set +x; echo; echo; set -x
147 autoreconf -fi
148 set +x; echo; echo; set -x
149 ./configure --prefix="$prefix" --with-systemdsystemunitdir=no $CONFIGURE_FLAGS $configure_opts
150 elif [ -f CMakeLists.txt ]; then
151 rm -rf build && mkdir build && cd build || exit 1
152 set +x; echo; echo; set -x
Andre Puschmann8e1ba792020-04-20 15:12:55 +0200153 cmake -DCMAKE_INSTALL_PREFIX=$prefix $configure_opts ../
Pau Espin Pedroladdf78e2020-02-03 15:47:01 +0100154 else
155 echo "Unknwown build system" && exit 1
156 fi
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200157 set +x; echo; echo; set -x
158 make -j8 || make # libsmpp34 can't build in parallel
159 set +x; echo; echo; set -x
160 make install
161}
162
Pau Espin Pedrol1828d352018-05-17 18:06:15 +0200163prune_files() {
164 bindir="$1"
165 wanted_binaries="$2"
166
167 if [ ! -d "$prefix_real/$bindir" ]; then return; fi
168 # remove binaries not intended to originate from this build
169 cd "$prefix_real/$bindir"
170 for f in * ; do
171 if [ -z "$(echo "_ $wanted_binaries _" | grep " $f ")" ]; then
172 rm "$f"
173 fi
174 done
175
176 # ensure requested binaries indeed exist
177 for b in $wanted_binaries ; do
178 if [ ! -f "$b" ]; then
179 set +x; echo "ERROR: no such binary: $b in $prefix_real/$bindir/"; set -x
180 ls -1 "$prefix_real/$bindir"
181 exit 1
182 fi
183 done
184}
185
Holger Hans Peter Freyther9cf1c8a2018-11-04 14:43:17 +0000186add_rpath() {
187 # Adds an RPATH to executables in bin/ or sbin/ to search for the
188 # (Osmocom) libraries in `dirname /proc/self/exe`/../lib/. Adds an
189 # RPATH to a library to search in the same directory as the library.
190 #
191 # NOTE: Binaries should not have the SUID bit set and should run as the
192 # user executing the binary.
193 #
194 # NOTE: $ORIGIN is not a shell variable but a feature of the dynamic
195 # linker that will be expanded at runtime. For details see:
196 # http://man7.org/linux/man-pages/man8/ld.so.8.html
197 #
198 # Add an rpath relative to the binary and library if the directory
199 # exists.
200 if [ -d bin/ ]; then
201 find bin -depth -type f -exec patchelf --set-rpath '$ORIGIN/../lib/' {} \;
202 fi
203 if [ -d sbin/ ]; then
204 find sbin -depth -type f -exec patchelf --set-rpath '$ORIGIN/../lib/' {} \;
205 fi
206 if [ -d lib/ ]; then
207 find lib -depth -type f -name "lib*.so.*" -exec patchelf --set-rpath '$ORIGIN/' {} \;
208 fi
209}
210
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200211create_bin_tgz() {
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200212 # build the archive that is going to be copied to the tester
Neels Hofmeyr1921c0f2017-09-04 16:34:18 +0200213
Pau Espin Pedrol1828d352018-05-17 18:06:15 +0200214 wanted_binaries_bin="$1"
215 wanted_binaries_sbin="$2"
Neels Hofmeyr1921c0f2017-09-04 16:34:18 +0200216
Pau Espin Pedrol1828d352018-05-17 18:06:15 +0200217 if [ -z "$wanted_binaries_bin" ] && [ -z "$wanted_binaries_sbin" ]; then
Neels Hofmeyr1921c0f2017-09-04 16:34:18 +0200218 set +x; echo "ERROR: create_bin_tgz needs a list of permitted binaries"; set -x
219 exit 1
220 fi
221
Pau Espin Pedrol1828d352018-05-17 18:06:15 +0200222 prune_files bin "$wanted_binaries_bin"
223 prune_files sbin "$wanted_binaries_sbin"
Pau Espin Pedroladdf78e2020-02-03 15:47:01 +0100224 # Drop all static libraries if exist:
225 rm -f $prefix_real/lib/*.a
226 rm -f $prefix_real/lib/*.la
Neels Hofmeyr713a1202017-09-07 00:57:46 +0200227
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200228 cd "$prefix_real"
Holger Hans Peter Freyther9cf1c8a2018-11-04 14:43:17 +0000229 add_rpath
Neels Hofmeyr53e758a2017-05-29 22:53:34 +0200230 this="$name.build-${BUILD_NUMBER-$(date +%Y-%m-%d_%H_%M_%S)}"
231 tar="${this}.tgz"
232 tar czf "$base/$tar" *
233 cd "$base"
234 md5sum "$tar" > "${this}.md5"
235}